const fs = require('fs');
const instance = require('sfcc-ci').instance;
const job = require('sfcc-ci').job;
const dw = require(process.cwd() + '/dw.json');

var options = { 
    pfx: 'build_cert.p12', 
    passphrase: dw.cert_pass 
};

module.exports = function(fileName, token){
    return new Promise((resolve, reject) => {
        if (token){
            instance.upload(dw.hostname, (fileName + ".zip"), token, (dw.hostname.startsWith('cert') ? options : {}), function(err){
                if(!err){
                    instance.import(dw.ocapi_endpoint || dw.hostname, (fileName + ".zip"), token, function(err, job_exe){
                        if(err){
                            reject(err);
                        }
                        else {    
                            var delay = setInterval(() => {
                                job.status(dw.ocapi_endpoint || dw.hostname, job_exe.job_id, job_exe.id, token, (err, job_exe) => {
                                    if (job_exe.status === 'OK') {
                                        clearInterval(delay);
                                        resolve(true);
                                    } else if (job_exe.status === 'ERROR') {
                                        clearInterval(delay);
                                        reject(false);
                                    }
                                });                                    
                            }, 1000);
                        }
                    });
                }
                else{
                    reject(err);
                }

                fs.unlinkSync(fileName + ".zip");
            });
        } else {
            reject(err);
        }
    });
}